NorthWind.WebMVC/Models/OrderViewModel.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using NorthWind.Entity;

namespace NorthWind.WebMVC.Models
{
    public class OrderViewModel
    {
        public Order Order { get; set; }

        public Customers Customer { get; set; }

        public Employees Employee { get; set; }

        public Shippers Shipper { get; set; }

        public List<OrderDetailMap> ListOrderDetail { get; set; }
    }
}

NorthWind.WebMVC/Controllers/CustomersController.cs
namespace NorthWind.WebMVC.Controllers
{
    using System;
    using System.Collections.Generic;
    using System.Linq;
    using System.Web;
    using System.Web.Mvc;
    using DataTables.Mvc;
    using NorthWind.Facade;
    using Newtonsoft.Json.Linq;

    using Common;
    using Entity;

    [Authorize]
    public class CustomersController
        : Controller
    {
        // GET: Customers
        public ActionResult Index()
        {
            //var actionName = this.ControllerContext.RouteData.Values[@"action"].ToString();
            var controllerName = this.ControllerContext.RouteData.Values[@"controller"].ToString();

            var jsFunc = @" function (data, type, full, meta) { return '<a href=""javascript:showForm(0,\'' + data + '\')"" style=""margin-right: 5px""><i class=""glyphicon glyphicon-search""></i></a>' + 
                    '<a href=""javascript:showForm(2,\'' + data + '\')"" style=""color: green; margin-right: 5px""><i class=""glyphicon glyphicon-edit""></i></a>' +
                    '<a href=""javascript:showForm(3,\'' + data + '\')"" style=""color: red; margin-right: 5px""><i class=""glyphicon glyphicon-remove""></i></a>'
                }";

            var customer = new Customers();

            var columns = new Object[]
            {
                new { Data = "CustomerID", Sortable = false, Width = 80, Render = new JRaw(jsFunc) },
                new { Title = "Customer ID", Data = Commons.GetPropertyInfo(customer, p => p.CustomerID).Name },
                new { Title = "Company Name", Data = Commons.GetPropertyInfo(customer, p => p.CompanyName).Name },
                new { Title = "Contact Name", Data = Commons.GetPropertyInfo(customer, p => p.ContactName).Name },
                new { Title = "Contact Title", Data = Commons.GetPropertyInfo(customer, p => p.ContactTitle).Name },
                new { Title = "Address", Data = Commons.GetPropertyInfo(customer, p => p.Address).Name },
                new { Title = "Country", Data = Commons.GetPropertyName(() => customer.Country) }
            };

            var lengthMenu = new Int32[][]
            {
                new Int32[] { 10, 25, 50, 100 },
                new Int32[] { 10, 25, 50, 100 }
            };

            var aaSorting = new[]
            {
                new Object[] { 1, "asc" }
            };

            var datatableConfig =
                new
                {
                    ServerSide = true,
                    Processing = true,
                    ScrollX = true,
                    Lengthmenu = lengthMenu,
                    AaSorting = aaSorting,
                    Ajax = new { Url = Url.Action(@"Get", controllerName) },
                    Columns = columns
                };
            
            this.ViewBag.Ngon.Dtc = datatableConfig;

            this.ViewBag.Ngon.Dataku = 
                new 
                {
                    TableId    = @"customers-dt",
                    LengthMenu = lengthMenu,
                    UrlAdd  = Url.Action(@"Create", controllerName).Substring(1),
                    UrlDetails = Url.Action(@"Details", controllerName).Substring(1),
                    UrlEdit = Url.Action(@"Edit", controllerName).Substring(1),
                    UrlDelete = Url.Action(@"Delete", controllerName).Substring(1)
                };

            return View();
        }

        // GET: Customers/Details/5
        public ActionResult Details(
            String Id)
            //Int32 id)
        {
            return this.PartialView(
                "_Details", 
                new Models.ProductViewModel());
        }

        // GET: Customers/Create
        public ActionResult Create()
        {
            return this.PartialView(
                @"_Add",
                new Models.ProductViewModel());
        }

        // POST: Customers/Create
        [HttpPost]
        public ActionResult Create(
            FormCollection collection)
        {
            if (this.Request.IsAjaxRequest())
            {
                return this.Content(@"success");
            }

            return this.RedirectToAction(@"Index");
        }

        // GET: Customers/Edit/5
        public ActionResult Edit(
            String Id)
            //Int32 id)
        {
            return PartialView(
                @"_Edit", 
                new Models.ProductViewModel());
        }

        // POST: Customers/Edit/5
        [HttpPost]
        public ActionResult Edit(
            String Id,
            //Int32 id, 
            FormCollection collection)
        {
            if (this.Request.IsAjaxRequest())
            {
                return this.Content(@"success");
            }

            return this.RedirectToAction(@"Index");
        }

        // GET: Customers/Delete/5
        public ActionResult Delete(
            String Id)
            //Int32 id)
        {
            return this.PartialView(
                @"_Delete",
                new Models.ProductViewModel());
        }

        // POST: Customers/Delete/5
        [HttpPost]
        public ActionResult Delete(
            String Id,
            //int id, 
            FormCollection collection)
        {
            if (this.Request.IsAjaxRequest())
            {
                return this.Content(@"success");
            }

            return this.RedirectToAction(@"Index");
        }

        public ActionResult Get([ModelBinder(typeof(DataTablesBinder))] IDataTablesRequest req)
        {
            var facade = new CustomersFacade();
            var sortedCol = req.Columns.GetSortedColumns();
            var strOrder = string.Empty;
            foreach (var col in sortedCol)
            {
                strOrder += string.IsNullOrEmpty(strOrder) ? "" : ",";
                strOrder += col.Data + (col.SortDirection == Column.OrderDirection.Ascendant ? " ASC" : " DESC");
            }

            var totalCount = facade.GetListItemsByCriteriaCount("1=1");
            var start = req.Start / req.Length + 1;
            var crtVal = req.Search.Value.Trim();
            var page = facade.PageDataForDataTables(crtVal, start, req.Length, strOrder);

            var result = new DataTablesResponse(req.Draw, page.Items, (int)page.TotalItems, totalCount);
            return Json(result, JsonRequestBehavior.AllowGet);
        }

        public ActionResult Lookup()
        {
            return this.PartialView("_Lookup");
        }
    }
}

NorthWind.WebMVC/Controllers/EmployeesController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using DataTables.Mvc;
using NorthWind.Facade;

namespace NorthWind.WebMVC.Controllers
{
    [Authorize]
    public class EmployeesController : Controller
    {
        // GET: Employees
        public ActionResult Index()
        {
            return View();
        }

        // GET: Employees/Details/5
        public ActionResult Details(int id)
        {
            return View();
        }

        // GET: Employees/Create
        public ActionResult Create()
        {
            return View();
        }

        // POST: Employees/Create
        [HttpPost]
        public ActionResult Create(FormCollection collection)
        {
            try
            {
                // TODO: Add insert logic here

                return RedirectToAction("Index");
            }
            catch
            {
                return View();
            }
        }

        // GET: Employees/Edit/5
        public ActionResult Edit(int id)
        {
            return View();
        }

        // POST: Employees/Edit/5
        [HttpPost]
        public ActionResult Edit(int id, FormCollection collection)
        {
            try
            {
                // TODO: Add update logic here

                return RedirectToAction("Index");
            }
            catch
            {
                return View();
            }
        }

        // GET: Employees/Delete/5
        public ActionResult Delete(int id)
        {
            return View();
        }

        // POST: Employees/Delete/5
        [HttpPost]
        public ActionResult Delete(int id, FormCollection collection)
        {
            try
            {
                // TODO: Add delete logic here

                return RedirectToAction("Index");
            }
            catch
            {
                return View();
            }
        }

        public ActionResult Get([ModelBinder(typeof(DataTablesBinder))] IDataTablesRequest req)
        {
            var facade = new EmployeeFacade();
            var sortedCol = req.Columns.GetSortedColumns();
            var strOrder = string.Empty;
            foreach (var col in sortedCol)
            {
                strOrder += string.IsNullOrEmpty(strOrder) ? "" : ",";
                strOrder += col.Data + (col.SortDirection == Column.OrderDirection.Ascendant ? " ASC" : " DESC");
            }

            var totalCount = facade.GetListItemsByCriteriaCount("1=1");
            var start = req.Start / req.Length + 1;
            var crtVal = req.Search.Value.Trim();
            var page = facade.PageDataForDataTables(crtVal, start, req.Length, strOrder);

            var result = new DataTablesResponse(req.Draw, page.Items, (int)page.TotalItems, totalCount);
            return Json(result, JsonRequestBehavior.AllowGet);
        }

        public ActionResult Lookup()
        {
            return PartialView("_Lookup");
        }
    }
}

NorthWind.WebMVC/Controllers/ProductsController.cs
using DataTables.Mvc;
using NorthWind.Entity;
using NorthWind.Facade;
using NorthWind.WebMVC.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using System.Web;
using System.Web.Mvc;

namespace NorthWind.WebMVC.Controllers
{
    [Authorize]
    public class ProductsController : Controller
    {
        // GET: Products
        public ActionResult Index()
        {
            return View();
        }

        // GET: Products/Details/5
        public ActionResult Details(int id)
        {
            var facade = new ProductsFacade();
            var obj = facade.GetItemByID(id);
            var ctg = new CategoryFacade().GetItemByID(obj.CategoryID);
            var supp = new SupplierFacade().GetItemByID(obj.SupplierID);
            var model = new ProductViewModel() { State=1, Products = obj, Category = ctg, Supplier = supp};
            return PartialView("_Details", model);
        }

        // GET: Products/Create
        public ActionResult Create()
        {
            var obj = new Products();
            var ctg = new Categories();
            var supp = new Suppliers();
            var model = new ProductViewModel { State = 0, Products = obj , Category = ctg, Supplier = supp };
            return PartialView("_Create", model);
        }

        // POST: Products/Create
        [HttpPost]
        public ActionResult Create(FormCollection collection)
        {
            try
            {
                // TODO: Add insert logic here

                return RedirectToAction("Index");
            }
            catch
            {
                return View();
            }
        }

        // GET: Products/Edit/5
        public ActionResult Edit(int id)
        {
            var facade = new ProductsFacade();
            var obj = facade.GetItemByID(id);
            var ctg = new CategoryFacade().GetItemByID(obj.CategoryID);
            var supp = new SupplierFacade().GetItemByID(obj.SupplierID);
            var list = new CategoryFacade().GetAllItems();
            var model = new ProductViewModel() { State = 2, Products = obj, Category = ctg, Supplier = supp, CategoryList = list };
            return PartialView("_Edit", model);
        }

        
        [HttpPost]
        public async Task<ActionResult> Edit(ProductViewModel model)
        {
            string errMsg = string.Empty;
            try
            {
                var facade = new ProductsFacade();
                bool status = facade.DataUpdate(model.Products.ProductID, model.Products, out errMsg);
                await Task<bool>.Factory.StartNew(() => status);
                if (!status)
                {
                    ModelState.AddModelError("", "Update data error \n, Error: " + errMsg);
                    return View("_Edit", model);
                }
                if (Request.IsAjaxRequest())
                {
                    return Content("success");
                }
            }
            catch
            {
                return View();
            }
            
            return RedirectToAction("Index");
        }

        // GET: Products/Delete/5
        public ActionResult Delete(int id)
        {
            return View();
        }

        // POST: Products/Delete/5
        [HttpPost]
        public ActionResult Delete(int id, FormCollection collection)
        {
            try
            {
                // TODO: Add delete logic here

                return RedirectToAction("Index");
            }
            catch
            {
                return View();
            }
        }

        public ActionResult Get([ModelBinder(typeof(DataTablesBinder))] IDataTablesRequest req)
        {
            var facade = new ProductsFacade();
            var sortedCol = req.Columns.GetSortedColumns();
            var strOrder = string.Empty;
            foreach (var col in sortedCol)
            {
                strOrder += string.IsNullOrEmpty(strOrder) ? "" : ",";
                strOrder += col.Data + (col.SortDirection == Column.OrderDirection.Ascendant ? " ASC" : " DESC");
            }

            var totalCount = facade.GetListItemsByCriteriaCount("1=1");
            var start = req.Start / req.Length + 1;
            var crtVal = req.Search.Value.Trim(); 
            var page = facade.PageDataForDataTables(crtVal, start, req.Length, strOrder);
            var result = new DataTablesResponse(req.Draw, page.Items, (int)page.TotalItems, totalCount);
            return Json(result, JsonRequestBehavior.AllowGet);
        }

        public ActionResult Lookup()
        {
            return PartialView("_Lookup");
        }
    }
}

NorthWind.WebMVC/Controllers/ShippersController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using DataTables.Mvc;
using NorthWind.Facade;

namespace NorthWind.WebMVC.Controllers
{
    [Authorize]
    public class ShippersController : Controller
    {
        // GET: Shippers
        public ActionResult Index()
        {
            return View();
        }

        // GET: Shippers/Details/5
        public ActionResult Details(int id)
        {
            return View();
        }

        // GET: Shippers/Create
        public ActionResult Create()
        {
            return View();
        }

        // POST: Shippers/Create
        [HttpPost]
        public ActionResult Create(FormCollection collection)
        {
            try
            {
                // TODO: Add insert logic here

                return RedirectToAction("Index");
            }
            catch
            {
                return View();
            }
        }

        // GET: Shippers/Edit/5
        public ActionResult Edit(int id)
        {
            return View();
        }

        // POST: Shippers/Edit/5
        [HttpPost]
        public ActionResult Edit(int id, FormCollection collection)
        {
            try
            {
                // TODO: Add update logic here

                return RedirectToAction("Index");
            }
            catch
            {
                return View();
            }
        }

        // GET: Shippers/Delete/5
        public ActionResult Delete(int id)
        {
            return View();
        }

        // POST: Shippers/Delete/5
        [HttpPost]
        public ActionResult Delete(int id, FormCollection collection)
        {
            try
            {
                // TODO: Add delete logic here

                return RedirectToAction("Index");
            }
            catch
            {
                return View();
            }
        }

        public ActionResult Get([ModelBinder(typeof(DataTablesBinder))] IDataTablesRequest req)
        {
            var facade = new ShipperFacade();
            var sortedCol = req.Columns.GetSortedColumns();
            var strOrder = string.Empty;
            foreach (var col in sortedCol)
            {
                strOrder += string.IsNullOrEmpty(strOrder) ? "" : ",";
                strOrder += col.Data + (col.SortDirection == Column.OrderDirection.Ascendant ? " ASC" : " DESC");
            }

            var totalCount = facade.GetListItemsByCriteriaCount("1=1");
            var start = req.Start / req.Length + 1;
            var crtVal = req.Search.Value.Trim();
            var page = facade.PageDataForDataTables(crtVal, start, req.Length, strOrder);

            var result = new DataTablesResponse(req.Draw, page.Items, (int)page.TotalItems, totalCount);
            return Json(result, JsonRequestBehavior.AllowGet);
        }

        public ActionResult Lookup()
        {
            return PartialView("_Lookup");
        }
    }
}

NorthWind.WebMVC/Views/Orders/Index.cshtml
<div class="row">
    <div class="col-md-12">
        <h2>Order List</h2>
    </div>
</div>
<div class="row">
    <div class="col-md-12">
        <div class="pull-right" style="margin-bottom: 10px">
            <button type="button" class="btn btn-primary btn-sm" onclick="showCreate()"><i class="glyphicon glyphicon-plus"></i> Add New</button>
        </div>
    </div>
</div>
<div class="row">
    <div class="col-md-12">
        <table id="orders-dt" class="table table-striped table-bordered"></table>
    </div>
</div>

<div id="modal-container" class="modal fade" data-backdrop="static"></div>
 
<div id="order-detail" class="modal fade" data-backdrop="static"></div>

<script type="text/javascript">
    var lengthMenu = [[10, 25, 50, 100], [10, 25, 50, 100]];
    var orderdt = $('#orders-dt').DataTable({
                    serverSide: true,
                    processing: true,
                    scrollX: true,
                    aaSorting: [[1, 'asc']],
                    ajax: {
                        url: "@Url.Action("Get", "Orders")"
                    },
                    columns: [
                        {
                            data: 'OrderID', render: function (data) {
                                return '<a id="btnDetail" href="javascript:showDetail(' + data + ')"><i class="glyphicon glyphicon-search"></i></a>' +
                                    '<a id="btnEdit" href="javascript:showEdit(' + data + ')" style="color: green; margin-left: 5px"><i class="glyphicon glyphicon-edit"></i></a>' +
                                    '<a id="btnDetail" href="javascript:deleteData(' + data + ')" style="color: red; margin-left: 5px"><i class="glyphicon glyphicon-remove"></i></a>';
                            }, width: 80, sortable: false
                        },
                        { title: 'Order ID', data: 'OrderID', width: 80 },
                        { title: 'Customer', data: 'CustomerName' },
                        { title: 'Employee', data: 'EmployeeName' },
                        { title: 'OrderDate', data: 'OrderDate', render: function (data) { return convertToDate(data); } },
                        { title: 'RequiredDate', data: 'RequiredDate', render: function (data) { return convertToDate(data); } },
                        { title: 'ShippedDate', data: 'ShippedDate', render: function (data) { return convertToDate(data); } },
                        { title: 'Shipper', data: 'ShipperName' },
                        { title: 'ShipName', data: 'ShipName' },
                        { title: 'ShipCity', data: 'ShipCity' },
                        { title: 'ShipCountry', data: 'ShipCountry' }
                    ],
                    lengthMenu: lengthMenu
    });

    function showCreate() {
        $.get("Orders/Create", function (data) {
            $('#modal-container').html(data);
            $('#modal-container').modal();
        });
    }

    function showDetail(id) {
        $.get("Orders/Details/" + id, function (data) {
            $('#modal-container').html(data);
            $('#modal-container').modal();
        });
    }
    function showEdit(id) {
        $.get("Orders/Edit/" + id, function (data) {
            $('#modal-container').html(data);
            $('#modal-container').modal();
        });
    }

    function deleteData(id) {
        orderdt.ajax.reload();
    }


    function OnSuccess(data) {
        if (data !== 'success') {
            $("#modal-container").html(data);
            return;
        }
        $("#modal-container").modal('hide');
        $("#modal-container").html("");
        orderdt.ajax.reload();
    }
</script>

@Html.Action("Lookup", "Employees")
@Html.Action("Lookup", "Customers")
@Html.Action("Lookup", "Shippers")
@Html.Action("Lookup", "Products")

NorthWind.WebMVC/Views/Orders/_OrderDetailCreateEdit.cshtml
@model NorthWind.Entity.OrderDetailMap

@using (Ajax.BeginForm("AddEditOrderDetail", "Orders", new AjaxOptions { HttpMethod = "POST", OnSuccess = "UpdateListOrderDetail" }))
{ 
    <div class="modal-dialog" data-backdrop="static">
    <div class="modal-content">
        <div class="modal-header">
            <span class="close" onclick="$('#order-detail').modal('hide')">&times;</span>
            <h3>Order Product Detail</h3>
        </div>
        <div class="modal-body">
            <div class="form-horizontal">
                @Html.ValidationSummary(true, "", new { @class = "text-danger" })                
                <div class="form-group">
                    <label class="control-label col-md-4">Order ID</label>
                    <div class="col-md-4">                        
                        @Html.TextBoxFor(x => x.OrderID, new { @readonly = true, @class = "form-control" })
                    </div>
                </div>
                <div class="form-group">
                    <label class="control-label col-md-4">Product</label>
                    <div class="col-md-8">
                        <div class="input-group">
                            @Html.HiddenFor(x => x.ProductID)
                            @Html.TextBoxFor(x => x.ProductName, new { @class = "form-control freeze" })
                            @{
                                if (Model.ProductID == 0)
                                {
                                    <div class="input-group-btn">
                                        <button type="button" class="btn btn-primary" onclick="selectProduct()"><i class="glyphicon glyphicon-search"></i></button>
                                    </div>
                                }
                                else
                                {
                                    <div class="input-group-addon">
                                    </div>
                                }
                            }
                        </div>
                    </div>
                </div>
                <div class="form-group">
                    <label class="control-label col-md-4">Unit Price</label>
                    <div class="col-md-4">
                        @Html.TextBoxFor(x => x.UnitPrice, new { @Value = Model.UnitPrice.ToString("0.##"), @class = "form-control digit" })
                    </div>
                </div>
                <div class="form-group">
                    <label class="control-label col-md-4">Quantity</label>
                    <div class="col-md-4">
                        @Html.TextBoxFor(x => x.Quantity, new { @class = "form-control digit" })
                    </div>
                </div>
                <div class="form-group">
                    <label class="control-label col-md-4">Discount</label>
                    <div class="col-md-4">
                        @Html.TextBoxFor(x => x.Discount, new { @Value = Model.Discount.ToString("0.##"), @class = "form-control digit" })
                    </div>
                </div>
            </div>
        </div>
        <div class="modal-footer">
            <button type="submit" class="btn btn-primary" onclick=""><i class="glyphicon glyphicon-save"></i> Save</button>
            <button type="button" class="btn btn-default" onclick="$('#order-detail').modal('hide')"><i class="glyphicon glyphicon-remove"></i> Close</button>
        </div>
    </div>
</div>

}

<script type="text/javascript">
    $('.digit').digits();
    $('.freeze').freeze();

    function selectProduct(){
        $("#lookup-prod").modal();
    }
</script>

NorthWind.WebMVC/Views/Orders/_OrderDetailVIew.cshtml
@model NorthWind.Entity.OrderDetailMap

<div class="modal-dialog" data-backdrop="static">
    <div class="modal-content">
        <div class="modal-header">
            <span class="close" onclick="$('#order-detail').modal('hide')">&times;</span>
            <h3>Order Product Detail</h3>
        </div>
        <div class="modal-body">
            <div class="form-horizontal">
                <div class="form-group">
                    <label class="control-label col-md-4">Order ID</label>
                    <div class="col-md-4">
                        @Html.TextBoxFor(x=>x.OrderID, new { @readonly=true, @class="form-control"})
                    </div>
                </div>
                <div class="form-group">
                    <label class="control-label col-md-4">Product</label>
                    <div class="col-md-8">
                        <div class="input-group">
                            @Html.HiddenFor(x => x.ProductID)
                            @Html.TextBoxFor(x => x.ProductName, new { @readonly = true, @class = "form-control freeze" })
                            <div class="input-group-addon">

                            </div>
                        </div>
                    </div>
                </div>
                <div class="form-group">
                    <label class="control-label col-md-4">Unit Price</label>
                    <div class="col-md-4">
                        @Html.TextBoxFor(x => x.UnitPrice, new { @readonly = true, @class = "form-control digit" })
                    </div>
                </div>
                <div class="form-group">
                    <label class="control-label col-md-4">Quantity</label>
                    <div class="col-md-4">
                        @Html.TextBoxFor(x => x.Quantity, new { @readonly = true, @class = "form-control digit" })
                    </div>
                </div>
                <div class="form-group">
                    <label class="control-label col-md-4">Discount</label>
                    <div class="col-md-4">
                        @Html.TextBoxFor(x => x.Discount, new { @readonly = true, @class = "form-control digit" })
                    </div>
                </div>
            </div>
        </div>
        <div class="modal-footer">
            <button type="button" class="btn btn-default" onclick="$('#order-detail').modal('hide')"><i class="glyphicon glyphicon-remove"></i> Close</button>
        </div>
    </div>
</div>
<script type="text/javascript">
    $('.digit').digits();
    $('.freeze').freeze();
</script>